# -*- coding: utf-8 -*-

import pylab, random

#set line width
pylab.rcParams['lines.linewidth'] = 4
#set font size for titles 
pylab.rcParams['axes.titlesize'] = 20
#set font size for labels on axes
pylab.rcParams['axes.labelsize'] = 20
#set size of numbers on x-axis
pylab.rcParams['xtick.labelsize'] = 16
#set size of numbers on y-axis
pylab.rcParams['ytick.labelsize'] = 16
#set size of ticks on x-axis
pylab.rcParams['xtick.major.size'] = 7
#set size of ticks on y-axis
pylab.rcParams['ytick.major.size'] = 7
#set size of markers, e.g., circles representing points
#set numpoints for legend
pylab.rcParams['legend.numpoints'] = 1

#Figure 20.1 has no code

#Figure 20.2
def calcBayes(priorA, probBifA, probB):
    """priorA: 事象Aの事前確率でBとは独立
       probBifA: Aが与えられた条件付きのBの確率
       probB: 事象Bの確率
       Bが与えられた条件下で事象Aを得る事後確率が結果として戻される"""
    return priorA*probBifA/probB

priorA = 1/3
prob6ifA = 1/5
prob6 = (1/5 + 1/6 + 1/7)/3

postA = calcBayes(priorA, prob6ifA, prob6)
print('タイプAである確率 =', round(postA, 4))
postA = calcBayes(postA, prob6ifA, prob6)
print('タイプAである確率 =', round(postA, 4))



#Figure 20.3
numRolls = 200
postA = priorA
for i in range(numRolls+1):
    if i%(numRolls//10) == 0:
        print(i,' 回振った時点でタイプAである確率 = ',
              round(postA, 4))
    isSix = random.random() <= 1/7 #サイコロはタイプCである
    if isSix:
        postA = calcBayes(postA, prob6ifA, prob6)
    else:
        postA = calcBayes(postA, 1 - prob6ifA, 1 - prob6)