# -*- coding: utf-8 -*-

import pylab, random

#直線の幅を指定
pylab.rcParams['lines.linewidth'] = 4
#タイトルのフォントサイズを指定
pylab.rcParams['axes.titlesize'] = 20
#軸のラベルのフォントサイズを指定
pylab.rcParams['axes.labelsize'] = 20
#x軸の数のサイズを指定
pylab.rcParams['xtick.labelsize'] = 16
#y軸の数のサイズを指定
pylab.rcParams['ytick.labelsize'] = 16
#x軸上のメモリのサイズを指定
pylab.rcParams['xtick.major.size'] = 7
#y軸上のメモリのサイズを指定
pylab.rcParams['ytick.major.size'] = 7
#マーカーのサイズを指定．例：点を表す円
#凡例に対するnumpointsを指定
pylab.rcParams['legend.numpoints'] = 1

#Figures 21.1 contains no code

#Figure 21.2
def plotHousing(impression):
    """Assumes impression a str. Must be one of 'flat',
         'volatile,' and 'fair'
       Produce bar chart of housing prices over time"""
    """impressionは文字列と仮定する．impressionは，flat,volatileまたはfairのいずれかでなければならない．
        この関数は，時間変化に対する住宅価格の棒グラフを求める．"""
    f = open('midWestHousingPrices.txt', 'r')
    #ファイルの各行には，アメリカ合衆国中西部における，年，四半期，価格が書かれている．
    labels, prices = ([], [])
    for line in f:
        year, quarter, price = line.split()
        label = year[2:4] + '\n Q' + quarter[1]
        labels.append(label)
        prices.append(int(price)/1000)
    quarters = pylab.arange(len(labels)) #棒グラフにおける棒のx座標
    width = 0.8 #棒グラフでの各棒の幅
    pylab.bar(quarters, prices, width)
    pylab.xticks(quarters+width/2, labels)
    pylab.title('Housing Prices in U.S. Midwest')
    pylab.xlabel('Quarter')
    pylab.ylabel('Average Price ($1,000\'s)')
    if impression == 'flat':
        pylab.ylim(1, 500)
    elif impression == 'volatile':
        pylab.ylim(180, 220)
    elif impression == 'fair':
        pylab.ylim(150, 250)
    else:
        raise ValueError

plotHousing('flat')
pylab.figure()
plotHousing('volatile')
pylab.figure()
plotHousing('fair')

#Figures 21.3-21.8 contain no code

#Figure 21.9
def juneProb(numTrials):
    june48 = 0
    for trial in range(numTrials):
      june = 0
      for i in range(446):
          if random.randint(1,12) == 6:
              june += 1
      if june >= 48:
          june48 += 1
    jProb = round(june48/numTrials, 4)
    print('Probability of at least 48 births in June =', jProb)

#figure 21.10
def anyProb(numTrials):
    anyMonth48 = 0
    for trial in range(numTrials):
      months = [0]*12
      for i in range(446):
          months[random.randint(0,11)] += 1
      if max(months) >= 48:
          anyMonth48 += 1
    aProb = round(anyMonth48/numTrials, 4)
    print('Probability of at least 48 births in some month =',aProb)

