﻿
#22.6
def minkowskiDist(v1, v2, p):
    """v1とv2は長さの等しい数値配列であるとする
       v1とv2の，p次のミンコウスキ距離を返す"""
    dist = 0.0
    for i in range(len(v1)):
        dist += abs(v1[i] - v2[i])**p
    return dist**(1/p)

#22.7
import pylab
class Animal(object):
    def __init__(self, name, features):
        """nameは文字列; featuresは数値のリストとする"""
        self.name = name
        self.features = pylab.array(features)
        
    def getName(self):
        return self.name

    def getFeatures(self):
        return self.features

    def distance(self, other):
        """otherはAnimalオブジェクトとする
           自分自身とother間のユークリッド距離を返す"""
        return minkowskiDist(self.getFeatures(),
                                             other.getFeatures(), 2)

#22.8
def compareAnimals(animals, precision):
    """animalsはAnimalオブジェクトのリスト, precisionは非負の整数とする
       それぞれのAnimal間のユークリッド距離の表を作る"""
    #行と列のラベルを得る
    columnLabels = []
    for a in animals:
        columnLabels.append(a.getName())
    rowLabels = columnLabels[:]
    tableVals = []
    #Animal間の距離を得る
    #それぞれの行について
    for a1 in animals:
        row = []
        #それぞれの列について
        for a2 in animals:
            if a1 == a2:
                row.append('--')
            else:
                distance = a1.distance(a2)
                row.append(str(round(distance, precision)))
        tableVals.append(row)
    #表を作る
    table = pylab.table(rowLabels = rowLabels, colLabels = columnLabels,
                                        cellText = tableVals,
                                        cellLoc = 'center',
                                        loc = 'center',
                                        colWidths = [0.2]*len(animals))
    table.scale(1, 2.5)
    pylab.savefig('distances')
