# -*- coding: utf-8 -*-

#コード 4.1
x = 25
epsilon = 0.01
numGuesses = 0
low = 0.0
high = max(1.0, x)
ans = (high + low)/2.0
while abs(ans**2 - x) >= epsilon:
    numGuesses += 1
    if ans**2 < x:
        low = ans
    else:
        high = ans
    ans = (high + low)/2.0
print('numGuesses =', numGuesses)
print(ans, 'is close to square root of', x)

#コード 4.2　コードなし

#コード 4.3
def f(x):
   def g():
      x = 'abc'
      print('x =', x)
   def h():
      z = x
      print('z =', z)
   x = x + 1
   print('x =', x)
   h()
   g()
   print('x =', x)
   return g

x = 3
z = f(x)
print('x =', x)
print('z =', z)
z()


#コード 4.4
def findRoot(x, power, epsilon):
    """xとepsilon >0 は整数もしくは浮動小数点数， power>=1を整数と仮定
       y**power がx のepsilon以内になるような浮動小数点数yを返す
       もし，そのような浮動小数点数が存在しなければNoneを返す"""
    if x < 0 and power%2 == 0: #負の数は平方根を持たない 
        return None
    low = min(-1.0, x)
    high = max(1.0, x)
    ans = (high + low)/2.0
    while abs(ans**power - x) >= epsilon:
        if ans**power < x:
            low = ans
        else:
            high = ans
        ans = (high + low)/2.0
    return ans

def testFindRoot():
    epsilon = 0.0001
    for x in [0.25, -0.25, 2, -2, 8, -8]:
        for power in range(1, 4):
            print('Testing x =', str(x), 'and power = ', power)
            result = findRoot(x, power, epsilon)
            if result == None:
                print('   No root')
            else:
                print('   ', result**power, '~=', x)

#コード 4.5
def factI(n):
   """n > 0 を整数と仮定
      n!を返す"""
   result = 1
   while n > 1:
      result = result * n
      n -= 1
   return result

def factR(n):
   """n > 0 を整数と仮定
      n!を返す"""
   if n == 1:
       return n
   else:
       return n*factR(n - 1)
       
#コード 4.6
def fib(n):
    """n > 0 を整数と仮定
       n 番目のフィボナッチ数を返す"""
    if n == 0 or n == 1:
        return 1
    else:
        return fib(n-1) + fib(n-2)

def testFib(n):
    for i in range(n+1):
        print('fib of', i, '=', fib(i))

#コード 4.7
def isPalindrome(s):
   """ s を文字列と仮定
       s が回文ならTrueを返し， それ以外ならFalseを返す
       ただし句読点，空白，大文字・小文字は無視する"""
   
   def toChars(s):
      s = s.lower()
      letters = ''
      for c in s:
        if c in 'abcdefghijklmnopqrstuvwxyz':
            letters = letters + c
      return letters

   def isPal(s):
      if len(s) <= 1:
        return True
      else:
        return s[0] == s[-1] and isPal(s[1:-1])
         
   return isPal(toChars(s))

#コード 4.8
def isPalindrome(s):
   """ s を文字列と仮定
       s が回文ならTrue を返し，それ以外ならFalseを返す
       ただし句読点，空白，大文字・小文字は無視する"""
   
   def toChars(s):
      s = s.lower()
      letters = ''
      for c in s:
        if c in 'abcdefghijklmnopqrstuvwxyz':
            letters = letters + c
      return letters

   def isPal(s):
      print('  isPal called with', s)
      if len(s) <= 1:
         print('  About to return True from base case')
         return True
      else:
         answer = s[0] == s[-1] and isPal(s[1:-1])
         print('  About to return', answer, 'for', s)
         return answer
         
   return isPal(toChars(s))

def testIsPalindrome():
   print('Try dogGod')
   print(isPalindrome('dogGod'))
   print('Try doGood')
   print(isPalindrome('doGood'))

testIsPalindrome()

#コード 4.9
def fib(x):
    """ x >= 0 を整数と仮定
        x 番目のフィボナッチ数を返す"""
    global numFibCalls
    numFibCalls += 1
    if x == 0 or x == 1:
        return 1
    else:
        return fib(x-1) + fib(x-2)

def testFib(n):
    for i in range(n+1):
        global numFibCalls
        numFibCalls = 0
        print('fib of', i, '=', fib(i))
        print('fib called', numFibCalls, 'times.')



pi = 3.14159

def area(radius):
    return pi*(radius**2)

def circumference(radius):
    return 2*pi*radius

def sphereSurface(radius):
    return 4.0*area(radius)

def sphereVolume(radius):
    return (4.0/3.0)*pi*(radius**3)
