# -*- coding: utf-8 -*-

def intersect(t1, t2):
    """t1とt2はタプルであると仮定する
       t1とt2両方に入っている要素を含むタプルを返す"""
    result = ()
    for e in t1:
        if e in t2:
            result += (e,)
    return result

def findExtremeDivisors(n1, n2):
    """n1とn2を正のint型とする．
       n1とn2の最小の公約数 > 1と最大の公約数からなる
       タプルを返す．
       公約数がない場合，(None, None)を返す．"""
    minVal, maxVal = None, None
    for i in range(2, min(n1, n2) + 1):
        if n1%i == 0 and n2%i == 0:
            if minVal == None:
                minVal = i
            maxVal = i
    return (minVal, maxVal)
    
#Figures 5.1-5.4 contain no code

#Figure 4.5 (repeated)
def factI(n):
   """Assumes n an int > 0
      Returns n!"""
   result = 1
   while n > 1:
      result = result * n
      n -= 1
   return result

def factR(n):
   """Assumes n an int > 0
      Returns n!"""
   if n == 1:
       return n
   else:
       return n*factR(n - 1)
       
#Figure 4.7 (repeated)
def fib(n):
    """Assumes n int >= 0
    Returns Fibonacci of n"""
    if n == 0 or n == 1:
        return 1
    else:
        return fib(n-1) + fib(n-2)
        
#Figure 5.5
def applyToEach(L, f):
   """Lをリストとし，fを関数とする．
      Lのそれぞれの要素eをf(e)に置き換えてLを更新する．"""
   for i in range(len(L)):
      L[i] = f(L[i])
      
L = [1, -2, 3.33]
print('L =', L)
print('Apply abs to each element of L.')
applyToEach(L, abs)
print('L =', L)
print('Apply int to each element of', L)
applyToEach(L, int)
print('L =', L)
print('Apply factorial to each element of', L)
applyToEach(L, factR)
print('L =', L)
print('Apply Fibonnaci to each element of', L)
applyToEach(L, fib)
print('L =', L)

#Figures 5.6 - 5.8 contain no code

#Figure 5.9
EtoF = {'bread':'pain', 'wine':'vin', 'with':'avec', 'I':'Je',
        'eat':'mange', 'drink':'bois', 'John':'Jean',
        'friends':'amis', 'and': 'et', 'of':'du','red':'rouge'}
FtoE = {'pain':'bread', 'vin':'wine', 'avec':'with', 'Je':'I',
        'mange':'eat', 'bois':'drink', 'Jean':'John',
        'amis':'friends', 'et':'and', 'du':'of', 'rouge':'red'}
dicts = {'English to French':EtoF, 'French to English':FtoE}

def translateWord(word, dictionary):
    if word in dictionary.keys():
        return dictionary[word]
    elif word != '':
        return '"' + word + '"'
    return word
    
def translate(phrase, dicts, direction):
    UCLetters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
    LCLetters = 'abcdefghijklmnopqrstuvwxyz'
    letters = UCLetters + LCLetters
    dictionary = dicts[direction]
    translation = ''
    word = ''
    for c in phrase:
        if c in letters:
            word = word + c
        else:
            translation = translation\
                          + translateWord(word, dictionary) + c
            word = ''
    return translation + ' ' + translateWord(word, dictionary)

print(translate('I drink good red wine, and eat bread.',
                dicts,'English to French'))
print(translate('Je bois du vin rouge.',
                dicts, 'French to English'))
