# -*- coding: utf-8 -*-

#Figure 7.1
def getRatios(vect1, vect2):
    """vect1とvect2を同じ長さのリストとする
       vect1[i]/vect2[i]を意味する値からなるリストを返す"""
    ratios = []
    for index in range(len(vect1)):
        try:
            ratios.append(vect1[index]/vect2[index])
        except ZeroDivisionError:
            ratios.append(float('nan')) #nan = Not a Number
        except:
            raise ValueError('getRatios called with bad arguments')
    return ratios


#Figure 7.2
def getRatios(vect1, vect2): 
    """vect1とvect2を同じ長さのリストとする
       vect1[i]/vect2[i]を意味する値からなるリストを返す"""
    ratios = []
    if len(vect1) != len(vect2):
        raise ValueError('getRatios called with bad arguments')
    for index in range(len(vect1)):
        vect1Elem = vect1[index]
        vect2Elem = vect2[index]
        if (type(vect1Elem) not in (int, float))\
           or (type(vect2Elem) not in (int, float)):
            raise ValueError('getRatios called with bad arguments')
        if vect2Elem == 0.0:
            ratios.append(float('NaN')) #NaN = Not a Number
        else:
            ratios.append(vect1Elem/vect2Elem)
    return ratios




#Figure 7.3
def getGrades(fname):
    try:
        gradesFile = open(fname, 'r') #読み込み用にファイルを開く
    except IOError:
        raise ValueError('getGrades could not open ' + fname)
    grades = []
    for line in gradesFile:
        try:
            grades.append(float(line))
        except:
            raise ValueError('Unable to convert line to float')
    return grades
  
try:
   grades = getGrades('quiz1grades.txt')
   grades.sort()
   median = grades[len(grades)//2]
   print('Median grade is', median)
except ValueError as errorMsg:
   print('Whoops.', errorMsg)